> For the complete documentation index, see [llms.txt](https://docs.postgresql.tw/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.postgresql.tw/reference/sql-commands/sql-begin.md).

# BEGIN

### BEGIN

BEGIN — start a transaction block

### Synopsis

```

BEGIN [ WORK | TRANSACTION ] [ transaction_mode [, ...] ]

where transaction_mode is one of:

    ISOLATION LEVEL { SERIALIZABLE | REPEATABLE READ | READ COMMITTED | READ UNCOMMITTED }
    READ WRITE | READ ONLY
    [ NOT ] DEFERRABLE
```

### Description

`BEGIN` initiates a transaction block, that is, all statements after a `BEGIN` command will be executed in a single transaction until an explicit [`COMMIT`](/reference/sql-commands/sql-commit.md) or [`ROLLBACK`](/reference/sql-commands/sql-rollback.md) is given. By default (without `BEGIN`), PostgreSQL executes transactions in “autocommit” mode, that is, each statement is executed in its own transaction and a commit is implicitly performed at the end of the statement (if execution was successful, otherwise a rollback is done).

Statements are executed more quickly in a transaction block, because transaction start/commit requires significant CPU and disk activity. Execution of multiple statements inside a transaction is also useful to ensure consistency when making several related changes: other sessions will be unable to see the intermediate states wherein not all the related updates have been done.

If the isolation level, read/write mode, or deferrable mode is specified, the new transaction has those characteristics, as if [`SET TRANSACTION`](/reference/sql-commands/sql-set-transaction.md) was executed.

### Parameters

`WORK`\
`TRANSACTION` : Optional key words. They have no effect.

Refer to [SET TRANSACTION](/reference/sql-commands/sql-set-transaction.md) for information on the meaning of the other parameters to this statement.

### Notes

[`START TRANSACTION`](/reference/sql-commands/sql-start-transaction.md) has the same functionality as `BEGIN`.

Use [`COMMIT`](/reference/sql-commands/sql-commit.md) or [`ROLLBACK`](/reference/sql-commands/sql-rollback.md) to terminate a transaction block.

Issuing `BEGIN` when already inside a transaction block will provoke a warning message. The state of the transaction is not affected. To nest transactions within a transaction block, use savepoints (see [SAVEPOINT](/reference/sql-commands/sql-savepoint.md)).

For reasons of backwards compatibility, the commas between successive *`transaction_modes`* can be omitted.

### Examples

To begin a transaction block:

```

BEGIN;
```

### Compatibility

`BEGIN` is a PostgreSQL language extension. It is equivalent to the SQL-standard command [`START TRANSACTION`](/reference/sql-commands/sql-start-transaction.md), whose reference page contains additional compatibility information.

The `DEFERRABLE` *`transaction_mode`* is a PostgreSQL language extension.

Incidentally, the `BEGIN` key word is used for a different purpose in embedded SQL. You are advised to be careful about the transaction semantics when porting database applications.

### See Also

[COMMIT](/reference/sql-commands/sql-commit.md), [ROLLBACK](/reference/sql-commands/sql-rollback.md), [START TRANSACTION](/reference/sql-commands/sql-start-transaction.md), [SAVEPOINT](/reference/sql-commands/sql-savepoint.md)

***

原文：[PostgreSQL 18.6 Documentation](https://www.postgresql.org/docs/18/sql-begin.html)（英文原文，待翻譯）


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.postgresql.tw/reference/sql-commands/sql-begin.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
